import PuppeteerBrowser from "./components/Puppeteer";
import chokidar from "chokidar";
import path from "path";
import "log-timestamp";

type config = { url: string };

class Index {

    constructor(private browserInstance: PuppeteerBrowser) {
        this.launch();
    };

    static async build(config: config) {
        let browserInstance = await PuppeteerBrowser.build(config.url);
        return new Index(browserInstance);
    };

   private async launch() {
        const self = this; 
        await self.browserInstance.start();
        const watcher = chokidar.watch(path.resolve(process.cwd() + "/dist/"), {ignored: /^\./, persistent: true});
        watcher
        .on('change', function(path: any) {
            self.browserInstance.reloadTab();
            console.log('File', path, 'has been updated');
        })
        .on('error', function(error: any) {console.error('Error happened', error);})
        // .on('unlink', function(path) {console.log('File', path, 'has been removed');})
        // .on('add', function(path) {console.log('File', path, 'has been added');})
    }

    public reloadChanges = async () => {
        this.browserInstance.reloadTab();
    }
}

export default Index;